---
title: Xamarin.Android warning XA1023
description: XA1023 warning code
ms.date: 05/18/2020
---
# Xamarin.Android warning XA1023

## Example messages

```
warning XA1023: Using the DX DEX Compiler is deprecated. Please update `$(AndroidDexTool)` to `d8`.
```

## Issue

Google has deprecated the DX DEX Compiler in favor of the [D8 DEX
Compiler][d8]. On [February 1, 2021][dx], DX will no longer be a part
of Android SDK or Android Studio.

[d8]: https://developer.android.com/studio/command-line/d8
[dx]: https://android-developers.googleblog.com/2020/02/the-path-to-dx-deprecation.html

## Solution

Update the `$(AndroidDexTool)` MSBuild property to `d8` to select the
D8 DEX Compiler. This property corresponds to the **Dex compiler**
setting in the Visual Studio project properties pages. Alternatively,
remove `<AndroidDexTool>` from the _.csproj_ file to let the build
select the default value `d8`.
