### Linker Behavior Change

Xamarin.Android has to consolidate changes to the Android APIs and how
they affect C# types. If you consider an example such as:

* API 28 has an `IFoo` interface in `Mono.Android.dll` for `v9.0`.
* C# code implements `IFoo` in class `Bar`.
* API 29 adds another method to `IFoo` in `Mono.Android.dll` for
  `v10.0`.
* Apps built targeting API 30 / `v10.0` will fix up `Bar` to implement
  the new method, but throw `Java.Lang.AbstractMethodError` if it was
  called.

If the linker didn't make this change, you would instead hit a crash
when trying to create an instance of type `Bar` such as:

    System.TypeLoadException: VTable setup of type 'Bar' failed.

Xamarin.Android has some performance improvements to the linker in
this area. Existing apps *should* not be affected.

Submit a [bug report][bug] if you find an issue in this area.

[bug]: https://github.com/xamarin/xamarin-android/wiki/Submitting-Bugs,-Feature-Requests,-and-Pull-Requests
